/*
 * @(#)$Id: DieMsg.java,v 1.2 2002/11/22 23:26:06 kris Exp $
 *
 *
 */

package mokan.comm;

import java.io.ObjectStreamClass;
import java.io.ObjectStreamField;
import mokan.debug.Event;

/**
 * Tell a Kan Virtual Machine to shut down
 *
 * @version	$Revision: 1.2 $, $Date: 2002/11/22 23:26:06 $
 * @author	Jerry James
 */
public final class DieMsg extends SysMessage {

    /**
     * The <var>serialVersionUID</var> for this class.  If you change the
     * signature of this class (field names or types, method names, parameter
     * names or types, adding or removing fields or methods, etc.), you
     * <strong>must</strong> change this value.  The recommended way is to use
     * the <code>serialver</code> tool.
     */
    static final long serialVersionUID = -5607841766527239837L;






    /**
     * The list of persistent fields for this class.  This is empty, because
     * that is the fastest option for <code>Externalizable</code> classes when 
     * we are not worried about versioning.
     */
    private static final ObjectStreamField[] serialPersistentFields =
	ObjectStreamClass.NO_FIELDS;

    /**
     * Create a new <code>DieMsg</code>
     */
    DieMsg() {
	super(false, false);
	Event.DEBUG(Event.MSG_CREATE, "Creating a die message");
    }

    /**
     * Handle this message by shutting down
     */
    public void handle() {
	super.handle();
	System.exit(0);
    }

    /**
     * Convert the <code>DieMsg</code> to a string
     *
     * @return a string representation of this <code>DieMsg</code>
     */
    public String toString() {
	return "DieMsg";
    }
}
