/*
 * @(#)$Id: NodeNumber.java,v 1.1.1.1 2002/11/06 22:10:25 kris Exp $
 *
 *
 */

package mokan.comm;

/**
 * A convenience object that holds a single integer, which identifies a
 * logical node by number.  This class is used in user applications; its use
 * is emitted by the Kan compiler.  Its purpose is to avoid accidentally
 * colliding with the method signature of a user method by ensuring that at
 * least one parameter has a type that will not appear in any user method
 * signature.
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:25 $
 * @author	Jerry James
 */
public final class NodeNumber {

    /**
     * The node number stored by this object
     */
    public final int node;

    /**
     * Create a new <code>NodeNumber</code> object
     *
     * @param nodeNum the node number to store
     */
    public NodeNumber(final int nodeNum) {
	node = nodeNum;
    }
}
