/*
 * @(#)$Id: HasExceptions.java,v 1.1.1.1 2002/11/06 22:10:25 kris Exp $
 *
 * JParse: a freely available Java parser
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Jerry James
 * Email: james@eecs.ukans.edu, james@ittc.ukans.edu, jamesj@acm.org
 * Address: EECS Department
 *          415 Snow Hall
 *          University of Kansas
 *          Lawrence, KS  66045
 */
package mokan.compiler;

/**
 * An interface indicating that the object represents an exception-throwing
 * Java entity
 *
 * @version $Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:25 $
 * @author Jerry James
 */
public interface HasExceptions {

    /**
     * Returns an array of <code>Type</code> objects that represent the types
     * of the checked exceptions that might be thrown by this Java entity.  If
     * this Java entity throws no checked exceptions, then an array of length
     * 0 is returned.
     *
     * @return an array of types representing the exceptions that this Java
     * entity might throw
     */
    public Type[] getExceptionTypes();
}
/* arch-tag: 82dc2568-fc06-467b-9d4e-000f86979844 */