/*
 * @(#)$Id: Hello.java,v 1.2 2002/11/12 02:57:33 kris Exp $
 *
 *
 */

package mokan.example.helloworld;

import mokan.app.Application;

/**
 * Say hello on all the nodes of a distributed system
 *
 * @version	$Revision: 1.2 $, $Date: 2002/11/12 02:57:33 $
 * @author	Jerry James
 */
public class Hello  implements Cloneable,mokan.obj.GlobalObj{

    public void sayHello() {
	System.out.println("==============================");
	System.out.println("==============================");
	System.out.println("Hello World!");
	System.out.println("==============================");
	System.out.println("==============================");
    }

    public static void main(Application app, String argv[]) {
	final int nodes = app.numNodes();
	final Hello.KanID[] objs = new Hello.KanID[nodes];

	// Create one Hello object per node
	for (int i = 0; i < nodes; i++) {
	    objs[i] = new Hello.KanID(i);
	}

	// Ask each Hello object to say hello
mokan.example.helloworld.FutureV[] futs = new mokan.example.helloworld.FutureV[nodes];
	for (int i = 0; i < nodes; i++) {
	    futs[i] = objs[i].sayHelloKanAsync() ;
	}

	// Make sure we are all done
	for (int i = 0; i < nodes; i++) {
	    futs[i].join();
	}
    }


    // Kan additions follow this line

    public final static int kanMinMethod = 0;

    public Object kanCallMethod(final int methodNum, final Object[] args)
        throws Exception {

        switch(methodNum) {
        case 0:
            sayHello();
            return null;
        default:
            return null;
        }
    }

    publicmokan.example.helloworld.Hello.KanID kanObjID;

    publicmokan.obj.ObjectID kanGetObjID() {
        return kanObjID;
    }

    public Hello(finalmokan.example.helloworld.Hello.KanID kanObjID) {
        this.kanObjID = kanObjID;
    }

    publicmokan.obj.GlobalObj kanClone() {
        try {
            return (kan.obj.GlobalObj)clone();
        } catch (Exception cloneEx) {
            return null;
        }
    }

    public void kanSetObject(kan.obj.GlobalObj obj) {
    }

    // Guard code follows this line

    public final static int kanMinGuard = 0;

    public boolean kanCallGuard(final int guardNum, final Object[] args) {
        return true;
    }

public static class KanID extends mokan.obj.ObjectID {

    public KanID() {}

public KanID(finalmokan.comm.LogicalNode node) {
        super(node);
        if (node.isLocal()) {
            new mokan.obj.KanObject(this, new mokan.example.helloworld.Hello(this),mokan.obj.Protocol.GENERAL);
        } else {
            finalmokan.obj.ObjectMgr mgr =
               mokan.comm.LogicalNode.getMyNode().getLocalHandler().manager;
            mgr.createRmtObject(this,mokan.example.helloworld.Hello.class, 0, new Object[0]);
        }
    }

    
    public void sayHello() {
       mokan.example.helloworld.Hello target = (kan.example.helloworld.Hello)callDirect();
        if (target == null || startCall()) {
            sayHelloKanAsync().join();
        } else {
            target.sayHello();
            endCall();
        }
    }

    public FutureV sayHelloKanAsync() {
        final FutureV fut = new FutureV();
       mokan.KanSystem.invokeMethod(this, fut, 0, null);
        return fut;
    }

    public final static KanID kanCreate(int constrNum, finalmokan.comm.LogicalNode node, final Object[] args) {
        switch (constrNum) {
        default:
            return new KanID(node);
        }
    }}
}
