/**
 * AbstractElectrical
 * Author: kkvilekal@acm.org 2004/07/06 02:09:32
 * arch-tag: c2c992c1-11c8-47c5-a577-f40c48edd640
 */
package mokan.example.mapview.emergency;


import java.util.ArrayList;
import java.io.Serializable;

import mokan.example.mapview.spatialdb.SpatialItem;
import mokan.example.mapview.spatialdb.SpatialLoc;

/**
 *  The <code>AbstractElectrical</code> description.
 *  @version $Revision$, $Date$
 *  @author Kristian Kvilekval (kkvilekval@acm.org)
 */
public abstract class AbstractElectrical  implements SpatialItem, Serializable
{
    /* Private/Public Variables */
    String name;
    SpatialLoc pt;
    AbstractElectrical connections[];
    ArrayList conns;


    public AbstractElectrical(String nm){
        name = nm;
        conns = new ArrayList();
    }
    public double getLatitude(){
        return pt.getlat();
    }
    public double getLongitude() {
        return pt.getlon();
    }
    public SpatialLoc getLocation() {
        return pt;
    }
    public void setLocation(SpatialLoc pt1) {
        pt = pt1;
    }
    public void setLocation(double lat, double lon) {
        pt = new SpatialLoc (lat, lon);
    }
    public void connect(AbstractElectrical ae) {
        conns.add (ae);
    }


    public void seal () {
        connections= (AbstractElectrical[])conns.toArray(new AbstractElectrical[conns.size()]);
        conns = null;
    }

    public AbstractElectrical[] getConnections() {
        if (connections != null)
            return connections;
        return (AbstractElectrical[])conns.toArray(new AbstractElectrical[conns.size()]);
    }

    public String toString() {
        return "name="+name+",pt="+pt;
    }

    public abstract void visit(ElectricalVisitor v);
}
