/**
 * OMGraphicVisitor
 * Author: kkvilekal@acm.org 2004/07/06 02:58:52
 * arch-tag: 1fe4237a-fa55-4dd2-8eec-18b2e7e2272b
 */
package mokan.example.mapview.emergency;

import java.awt.Color;
import java.awt.BasicStroke;

import com.bbn.openmap.omGraphics.OMGraphic;
import com.bbn.openmap.omGraphics.OMGraphicList;
import com.bbn.openmap.omGraphics.OMPoint;
import com.bbn.openmap.omGraphics.OMText;
import com.bbn.openmap.omGraphics.OMLine;

/**
 *  The <code>OMGraphicVisitor</code> description.
 *  @version $Revision$, $Date$
 *  @author Kristian Kvilekval (kkvilekval@acm.org)
 */
public class OMGraphicVisitor extends ElectricalVisitor {
    /* Private/Public Variables */

    public OMGraphicList graphics = new OMGraphicList();
    protected Color lineColor = Color.red;
    protected BasicStroke  stroke = new BasicStroke(2);

    public OMGraphicVisitor () {
    }



    public OMGraphicList getGraphicList() {
        return graphics;
    }

    protected OMGraphicList makegroup(AbstractElectrical n, String txt) {
        OMPoint circ;
        OMText text;

        int circle_r = 2;
        int circle_h = 5;
    
        // grouping
        OMGraphicList group = new OMGraphicList(2);
        
        // XY-Circle at LatLonPoint
        circ = new OMPoint((float)n.getLatitude(), 
                           (float)n.getLongitude(), circle_r);
        circ.setOval(true);
        circ.setFillPaint(lineColor);
        group.add(circ);
        
        // Info
        text = new OMText((float)n.getLatitude(), (float)n.getLongitude(), 
                          0, circle_h+10, 
                          txt, 
                          java.awt.Font.decode("SansSerif"), 
                          OMText.JUSTIFY_CENTER);
        text.setLinePaint(lineColor);
        group.add(text);

        return group;
    }


    public void visitJunction(Junction n) {
        graphics.add(makegroup(n, "Junction"));       
    }
    public void visitShutoff(Shutoff n) {
        graphics.add(makegroup(n, "shutoff"));       
    }
    public void visitTransformer(Transformer n) {
        graphics.add(makegroup(n, "Transformer"));       
    }
    public void visitCable(Cable n) {
        System.out.println (n);
        OMLine line = 
            new OMLine(n.pt1.getflat(),n.pt1.getflon(),
                       n.pt2.getflat(),n.pt2.getflon(),
                       OMGraphic.LINETYPE_STRAIGHT);

        line.setLinePaint(lineColor);
        line.setStroke(stroke);       
        graphics.add(line);

    }
}
