/*
 * @(#)$Id: TooManyFailuresException.java,v 1.2 2002/11/22 23:26:07 kris Exp $
 *
 *
 */

package mokan.fail;

import mokan.transact.TransactionAbortException;

/**
 * Thrown if the current transaction cannot be completed due to too many node
 * failures in the system.  That is, some t-resilient object is used by the
 * transaction, but more than t nodes failed.
 *
 * @version	$Revision: 1.2 $, $Date: 2002/11/22 23:26:07 $
 * @author	Jerry James
 */
final class TooManyFailuresException extends TransactionAbortException {

    /**
     * The <var>serialVersionUID</var> for this class.  If you change the
     * signature of this class (field names or types, method names, parameter
     * names or types, adding or removing fields or methods, etc.), you
     * <strong>must</strong> change this value.  The recommended way is to use
     * the <code>serialver</code> tool.
     */
    static final long serialVersionUID = -3580558626756775057L;



    /**
     * Constructs a <code>TooManyFailuresException</code> with no detail
     * message.
     */
    TooManyFailuresException() {
	super();
    }

    /**
     * Constructs a <code>TooManyFailuresException</code> with the specified
     * detail message.
     *
     * @param s the detail message.
     */
    TooManyFailuresException(final String s) {
	super(s);
    }
}
