package mokan.nameservice;

import java.util.*;
import mokan.comm.*;
import mokan.app.Application;

/**
 * This class holds global accessible instances. Those instances should be
 * singletons.
 */
public class Globals {

  /**
   * The application running on this node.
   * Currently ssuming ONE application at a time.
   */
  public static Application app = null;

  /**
   * The default port when a port is not designated.
   */
  public static final int DEFAULT_PORT = 5500;

  /**
   * The listening port, which can be designated by option -p
   */
  public static int listenPort = 0;

  //The followings are for name service

  /** The arrow directory protocol. */
  public static ArrowNameService nameService = new ArrowNameService();

  /** The neighbors of this node. */
  public static Set neighbors = Collections.synchronizedSet(new HashSet());

  /**
   * The map for (ObjectInput, LogicalNode)
   */
  public static Map objectInputMap = Collections.synchronizedMap(new HashMap());

  /**
   * The local physical node
   */
  public static PhysicalNode localPhysicalNode = null;

  /**
   * This class should not be instantiated.
   */
  private Globals() {
  }

}