package mokan.nameservice;

import mokan.comm.*;
import java.io.*;
import mokan.debug.*;

/**
 * QueryHomeReply corresponding to QueryHomeMsg.
 */
public class QueryHomeReply extends AppReply implements Externalizable {

  private LogicalNode home;

  static final long serialVersionUID = -2272549123160153732L;
  private static final ObjectStreamField[] serialPersistentFields =
      ObjectStreamClass.NO_FIELDS;

  public QueryHomeReply() {
    super(false, false);
  }

  public QueryHomeReply(QueryHomeMsg orig, LogicalNode home) {
    super(orig, false, false);
    this.home = home;
    Event.DEBUG(Event.MSG_CREATE, "Created ", this);
  }

  public LogicalNode getHome() {
    return home;
  }

  protected QueryHomeReply(boolean needsReset, boolean canBlock) {
    super(needsReset, canBlock);
  }

  public QueryHomeReply(AppMessage msg, boolean needsReset, boolean canBlock) {
    super(msg, needsReset, canBlock);
  }

  public void writeExternal(final ObjectOutput out) throws IOException {
    super.writeExternal(out);
    out.writeObject(home);
  }

  public void readExternal(final ObjectInput in) throws IOException,
      ClassNotFoundException {

    super.readExternal(in);
    home = (LogicalNode) in.readObject();
  }

  public String toString() {
      return "QueryHomeReply[" + home + "]";
  }

}