/*
 * @(#)$Id: ChangedObjectException.java,v 1.1.1.1 2002/11/06 22:10:27 kris Exp $
 *
 *
 */

package mokan.obj;

import java.io.ObjectStreamClass;
import mokan.transact.TransactionAbortException;

/**
 * Thrown if the current transaction is aborted from trying to access an
 * object that changed state during the transaction (stale copy).
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:27 $
 * @author	Jerry James
 */
public final class ChangedObjectException extends TransactionAbortException {

    /**
     * Constructs a <code>ChangedObjectException</code> with no detail
     * message.
     */
    ChangedObjectException() {
	super();
    }

    /**
     * Constructs a <code>ChangedObjectException</code> with the specified
     * detail message.
     *
     * @param s the detail message.
     */
    ChangedObjectException(final String s) {
	super(s);
    }
}
