/*
 * @(#)$Id: UnsatisfiedGuardException.java,v 1.1.1.1 2002/11/06 22:10:27 kris Exp $
 *
 *
 */

package mokan.obj;

import mokan.transact.TransactionAbortException;

/**
 * Thrown if the current transaction is killed to avoid deadlock due to an
 * unsatisfied guard.
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:27 $
 * @author	Jerry James
 */
public final class UnsatisfiedGuardException extends TransactionAbortException{


    /**
     * Constructs an <code>UnsatisfiedGuardException</code> with no detail
     * message.
     */
    public UnsatisfiedGuardException() {
	super();
    }

    /**
     * Constructs an <code>UnsatisfiedGuardException</code> with the specified
     * detail message.
     *
     * @param s the detail message.
     */
    public UnsatisfiedGuardException(final String s) {
	super(s);
    }
}
