/**
 * CallsiteVisitor
 * tag: kkvilekal@acm.org 2002/08/27 05:54:12
 */
package mokan.prefetch.analysis.classanalysis;


import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;


import de.fub.bytecode.Constants;
import de.fub.bytecode.generic.InstructionHandle;
import de.fub.bytecode.generic.InvokeInstruction;

import mokan.prefetch.util.RTMethod;
import mokan.prefetch.util.RTInstructionVisitor;

/**
 *  The <code>CallsiteVisitor</code> description.
 *  @version $Revision: 1.2 $, $Date: 2003/01/24 18:23:17 $
 *  @author Kristian Kvilekval (kkvilekval@acm.org)
 */
public class CallsiteVisitor extends RTInstructionVisitor {

    protected RTMethod method;
    ArrayList calls;
    
    CallsiteVisitor (RTMethod m) {
        method = m;
        calls = new ArrayList();
    }

    public void visitInvokeInstruction (InvokeInstruction instr) {
        String target = (instr.getMethodName(method.getConstantPoolGen())
                         +instr.getSignature(method.getConstantPoolGen()));
        
        // Record that Method m actually call the some function.
        String handleclass = instr.getClassName (method.getConstantPoolGen());
        //log.info ("Found call " + handleclass + "->" + target);
        // String signature = instr.getSignature(m.getConstantPoolGen());
        
        boolean vcall = !(instr.getOpcode()== Constants.INVOKESPECIAL
                          || instr.getOpcode()==Constants.INVOKESTATIC );
        
        Callsite cs =  new Callsite (method, 
                                     getPosition(), 
                                     handleclass, target,vcall);
        cs.setInterface(instr.getOpcode() == Constants.INVOKEINTERFACE);
        calls.add (cs);
    }

    Callsite[] getCallsites (){
        return  (Callsite[])calls.toArray(new Callsite[calls.size()]);
    }
}
