/*
 * 
 *
 * tag: kkvilekval@acm.org Sat Nov 10 14:47:50 2001 (BlockGraph)
 *
 */


package mokan.prefetch.analysis.shapeanalysis;

import java.util.List;

import agl.DirectedGraph;
import agl.DirectedGraphBuilder;
import agl.DirectedGraphNodeRep;
import agl.TopologicalVisitor;

import mokan.prefetch.util.RTMethod;
import klogger.Logger;

/**
 *  The <code>BlockGraph</code> maintains a graph of basic
 *  blocks for a method
 *  @version $Revision: 1.1.1.1 $, $Date: 2002/12/19 23:48:36 $
 *  @author Kristian Kvilekval
 */
public class BlockGraph   {

    /* Private/Public Variables */
    DirectedGraph blockGraph;
    BlockNode[] blocks;
    /**
     *  The default constructor
     */
    public BlockGraph (RTMethod m) {

        DirectedGraphBuilder dgb = 
            new DirectedGraphBuilder(new DirectedGraphNodeRep (),
                                     new DirectedGraphNodeRep ());

        
        blocks = new BlockFactory(dgb).generate (m);
        blockGraph = (DirectedGraph)dgb.getGraph();
    }

    public BlockNode getRoot () {
        return blocks[0];
    }


    public String toString() {
        return BlockFactory.toString(blocks);
    }

    /** Return the list of blocks in reverse topological order.
     *  i.e. A root before any children
     */
    public List getTopologicalOrder () {
        return TopologicalVisitor.reverseOrdering (blockGraph, getRoot());
    }

};
