/*
 * 
 *
 * tag: kkvilekval@acm.org Wed Nov  7 13:42:25 2001 (MethodTable)
 *
 */


package mokan.prefetch.analysis.shapeanalysis;

import java.io.Serializable;
import java.util.HashMap;
import java.util.AbstractMap;
import java.util.Set;

import mokan.prefetch.util.RTMethod;

/**
 *  The <code>MethodTable</code>  provides access the 
 *  method state from the RTMethod 
 *
 *    Map <RTMathod, MethodState> 
 *  
 *  @version $Revision: 1.1.1.1 $, $Date: 2002/12/19 23:48:36 $
 *  @author Kristian Kvilekval
 */
public class MethodTable extends AbstractMap implements Serializable {

    /* Private/Public Variables */
    private HashMap    name2state;

    /**
     *  The default constructor
     */
    public MethodTable () {
        name2state = new HashMap();
    }

    public   void putState (RTMethod m, MethodState ms) {
        name2state.put (m.toString(), ms);
    }

    public    MethodState getState (RTMethod m) {
        MethodState ms = (MethodState)name2state.get (m.toString());
        return ms;
    }

    public    MethodState getState (String methodname) {
        return (MethodState)name2state.get (methodname);
    }

    public boolean hasShape (RTMethod m) {
        return name2state.get (m.toString()) != null;
    }

    public String getLocalShape (RTMethod m, int arg) {
        return getState (m).getLocalShape (arg);
    }

    public String toString () {
        return name2state.values().toString();
    }

    public Set entrySet() {
        return name2state.entrySet();
    }


    public void logStatistics () {
    }
};
