/*
 * 
 *
 * tag: kkvilekval@acm.org Tue Nov  6 14:03:50 2001 (ShapeEdge)
 *
 */


package mokan.prefetch.analysis.shapeanalysis;

import java.io.Serializable;


import agl.Edge;
import agl.DirectedEdge;

/**
 *  The <code>ShapeEdge</code> description.
 *  @version $Revision: 1.1.1.1 $, $Date: 2002/12/19 23:48:36 $
 *  @author Kristian Kvilekval
 */
public class ShapeEdge implements DirectedEdge,Serializable {

    public final static String CREATE = "C";
    public final static String READ   = "R";
    public final static String WRITE  = "W";


    /* Private/Public Variables */
    public RTVariable base;
    public RTVariable link;

    public String field ;
    public int    mincount ;
    public int    maxcount;
    public String access; 
    /**
     *  The default constructor
     */
    public ShapeEdge ( String field, int count){
//         this.base = from;
//         this.link = to;
        this.field = field;
        this.mincount = count;
        this.maxcount = count;
        this.access = READ;
    }

    private ShapeEdge() {
    }

    public Edge setVertices(Object a,Object b) {
        base = (RTVariable)a; link = (RTVariable)b;
        return this;
    }
    

    public boolean equals (Object o) {
        if (o instanceof ShapeEdge) {
            return field.equals (((ShapeEdge)o).field);
        } else if (o instanceof String) {
            return field.equals (o);
        }
        return false;
    }


    public ShapeEdge copy () {
        ShapeEdge e = new ShapeEdge();
        e.field = field;
        e.mincount = mincount;
        e.maxcount = maxcount;
        return e;
    }

    // Unify the field of the shape edge with the 
    // given shape edge.
    public void unify(ShapeEdge e) {
        // assert (field == e.field)
        mincount = Math.min(mincount, e.mincount);
        maxcount = Math.max(maxcount, e.maxcount);
    }

    // DIRECTEDEDGE 
    public void setVertexA(RTVariable v) {
        base = v;
    }
    public String name () {
        return field;
    }
    
    public DirectedEdge swap(){
        return null;
    }

    public Object getVertexA () {
        return base;
    }
    public Object getVertexB () {
        return link;
    }
    public Object getSource () {
        return base;
    }
    public Object getSink () {
        return link;
    }
    public int getDirection () {
        return OUT;
    }

    /**
     *  @return a string representation of this <code>ShapeEdge</code> 
     */
    public String toString () {
        return field;
    }
};
