/*
 * 
 *
 * tag: kkvilekval@acm.org Fri Nov  9 17:30:03 2001 (AccessStrategy)
 *
 */


package mokan.prefetch.runtime;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.io.OutputStream;
import java.lang.reflect.Field;

import mokan.prefetch.util.xml.XMLWriter;

/**
 *  The Abstract <code>AccessStrategy</code> provides an interface
 *  for several AccessStrategies.  
 *  @version $Revision: 1.2 $, $Date: 2003/01/24 18:23:17 $
 *  @author Kristian Kvilekval
 */
abstract class AccessStrategy {

    /* Private/Public Variables */
    protected String ident;
    /**
     *  The default constructor
     */

    public AccessStrategy (String name) {
        this.ident = name;
    }
    /** (Re)Initialize the strategy */
    public void start () {}
    /** Stop the strategy (before dumping info) */
    public void stop  () {}
    public void dumpXML (XMLWriter p) {}

    public void methodExit(String name) {}

    /** Begin method instruction  */
    public abstract void methodEntry(String name, boolean analyzed);
    /** Clear cache of runtime objects */
    public abstract void clear ();
    /** Note allocation in method */
    public abstract void alloc (Object rtobj);
    /** Note access in method */
    public abstract void access(Object rtobj, boolean iswrite);
    /** Possible preload an obejct with is shape-graph */
    public abstract void preload (Object rtobj, String access);
    /** Test if strategies cache contains a runtime object */
    public abstract boolean contains (Object rtobj);

    public synchronized long transactBegin(Object[] objs){
        return 0;
    }

    public synchronized void transactEnd(){
    }

    public final static String orep(Object o) {
        if (o != null) {
            StringBuffer sb = new StringBuffer ();
            sb.append (o.getClass().getName());
            sb.append ('@');
            sb.append (Integer.toHexString (System.identityHashCode(o)));
            return sb.toString();
        }                       
        return "null";
    }
};






