/*
 * 
 *
 * tag: kkvilekval@acm.org Tue Nov 13 17:21:26 2001 (LogStrategy)
 *
 */


package mokan.prefetch.runtime;

import java.io.Writer;
import java.io.File;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.FileWriter;
import klogger.Logger;


/**
 *  The <code>LogStrategy</code> description.
 *  @version $Revision: 1.1.1.1 $, $Date: 2002/12/19 23:48:36 $
 *  @author Kristian Kvilekval
 */
public class LogStrategy extends AccessStrategy {

    protected final static Logger log = Logger.getLogger ("mokan.prefetch.Log");
    

    /* Private/Public Variables */
    PrintWriter out;
//    InfiniteCache cache;

    /**
     *  The default constructor
     */
    public LogStrategy (String logfilename) {
        super("LOG");
        try {
            out = new PrintWriter(new BufferedWriter(new FileWriter(logfilename)));
        } catch (Exception e) {
            log.severe ("Couldn't open logfile");
        }
//        cache = new InfiniteCache();

    }
    public LogStrategy (File logfile) {
        super("LOG");
        try {
        out = new PrintWriter(new BufferedWriter(new FileWriter(logfile)));
        } catch (Exception e) {
            System.err.println ("Couldn't open logfile");
        }
//        cache = new InfiniteCache();
    }

    public void start () {
    }
    public void stop () {
    }
    public void clear () {
    }

    public  void methodEntry (String name, boolean analyzed){
        log.trace ("B-" + name);        
    }
    public  void methodExit (String name){
        log.trace ("E-" + name);        
    }
    public void alloc (Object rtobj){
//         if (cache.getentry (rtobj) == null) {
//             cache.allocate (rtobj);
//             log.trace ("A-" + obRep(rtobj)+":"+rtobj.getClass());        
//         }
    }
    public void access(Object rtobj, boolean iswrite){
        log.trace ((iswrite?"w ":"r ") + obRep(rtobj));        
    }
    public void preload (Object rtobj, String access){
        log.trace ("F-"+obRep(rtobj)+":"+ access);
    }
    public boolean contains (Object rtobj) {
        return false;
    }
    public  void disconnect (int time) {
        log.trace ("D-"+ time);
     }
    public void reconnect () {
        log.trace ("R");
     }


    /** return a unique ID for each object */
     public String obRep (Object o) {

//         AbstractCache.Entry n=cache.get (o);
//         return (n.index<0)?"*":Integer.toString(n.index);
         return o.toString();

    }

};
