/**
 * GraphConvert
 * tag: kkvilekal@acm.org 2002/08/30 19:17:18
 * Copyright kkvilekval@acm.org.   See COPYRIGHT for details.
 */
package mokan.prefetch.util;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.ArrayList;
import java.util.HashSet;


import agl.DirectedGraph;
import agl.Graph;
import agl2.Digraph;
import agl2.DigraphBuilder;

/**
 *  The <code>GraphConvert</code> description.
 *  @version $Revision: 1.1.1.1 $, $Date: 2002/12/19 23:48:36 $
 *  @author Kristian Kvilekval (kkvilekval@acm.org)
 */
public class GraphConvert {
    /* Private/Public Variables */

    HashSet visited = new HashSet ();
    Graph        graph;
    DigraphBuilder gb;
    

    public Digraph convert2agl2 (DirectedGraph dg, Object root) {
        gb = new DigraphBuilder ();
        graph = dg;
        visitNode (root);
        return gb.getDigraph();
    }

    private void visitNode (Object v) {
        visited.add (v);
        gb.addVertex (v);
        Iterator adjl = graph.getAdjacentVertices(v).iterator();
        while (adjl.hasNext()) {
            Object adj = adjl.next();
            gb.addEdge (v, adj, null);
            if (!visited.contains (adj)) {
                //System.out.println ("DFSVisit" + adj);
                visitNode (adj);
            }
        }
    }
}
