/*
 * 
 *
 * tag: kkvilekval@acm.org Thu Oct 18 11:54:35 2001 (MultiIterator)
 *
 */


package mokan.prefetch.util;

import java.util.Collection;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.NoSuchElementException;

/**
 *  The <code>MultiIterator</code> iterator over several iterator
 *  @version $Revision: 1.1.1.1 $, $Date: 2002/12/19 23:48:36 $
 *  @author Kristian Kvilekval
 */
public class MultiIterator implements Iterator {


    final Iterator[] iterators;
    int   it=0;
    /* Private/Public Variables */

    /**
     *  The default constructor
     */
    public MultiIterator (Iterator i1, Iterator i2) {
        iterators = new Iterator[] { i1, i2 };
    }
    public MultiIterator (Iterator i1, Iterator i2, Iterator i3) {
        iterators = new Iterator[] { i1, i2, i3};
    }
    public MultiIterator (Collection iters) {
        iterators = (Iterator[])iters.toArray(new Iterator[iters.size()]);
    }

    /** Given a set of container  get an iterator for all of them */
    public static MultiIterator forContainers (Collection  containers) {
        Iterator container = containers.iterator();
        ArrayList iters = new ArrayList();
        while (container.hasNext()) {
            iters.add( ((Collection)container.next()).iterator());
        }
        return new MultiIterator(iters);
    }

    public boolean hasNext() {
        for (int j=it; j<iterators.length; j++)
            if (iterators[j].hasNext())
                return true;
        return false;
    }
    public Object next() {
        while (it < iterators.length && !iterators[it].hasNext() )
            it++;
        if (it < iterators.length && iterators[it].hasNext())
            return iterators[it].next();
        else
            throw new NoSuchElementException();
    }
    public void remove() {
        iterators[it].remove();
    }
};
