/*
 * 
 *
 * tag: kkvilekval@acm.org Tue Aug  7 00:04:21 2001 (MultiMap)
 *
 */


package mokan.prefetch.util;

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;

/**
 *  The <code>MultiMap</code> description.
 *  @version $Revision: 1.1.1.1 $, $Date: 2002/12/19 23:48:36 $
 *  @author Kristian Kvilekval
 */
public class MultiMap {

    /* Private/Public Variables */
    HashMap key2coll;

    
    protected HashSet getCollection (Object k) {
        HashSet c = (HashSet)key2coll.get (k);
        if (c == null) {
            key2coll.put(k, c = new HashSet ());
        }
        return c;
    }
    public MultiMap () {
        key2coll = new HashMap();
    }


    public boolean  add(Object key, Object value) {
        return getCollection(key).add (value);
    }
    public boolean addAll(Object key, Collection values){
        return getCollection (key).addAll (values);
    }

    public void  remove(Object key, Object value) {
         getCollection (key).remove (value);
        
    }
    public Collection getValues(Object key) {
        return getCollection (key);
    }
    public boolean contains(Object a, Object b) {
        return getCollection(a).contains (b);
    }

    /**
     *  @return a string representation of this <code>MultiMap</code> 
     */
    public String toString () {
        return key2coll.toString();
    }
};
