/*
 * 
 *
 * tag: kkvilekval@acm.org Mon Nov  5 21:01:45 2001 (WorkSet)
 *
 */


package mokan.prefetch.util;

import java.util.AbstractSet;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Iterator;

/**
 *  The <code>WorkSet</code> is a set with a an order.
 *  An element can be added only once.
 *  @version $Revision: 1.2 $, $Date: 2003/01/24 18:23:17 $
 *  @author Kristian Kvilekval
 */
public class WorkSet extends AbstractSet {

    /* Private/Public Variables */
    private HashSet    visited; 
    private LinkedList list;
    /**
     *  The default constructor
     */
    public WorkSet () {
        visited = new HashSet();
        list  = new LinkedList();
    }

    public boolean isEmpty () {
        return list.isEmpty();
    }

    public boolean add (Object o) {
        if (!visited.contains (o)) {
            visited.add (o);
            list.add (o);
            return true;
        }
        return false;
    }

    public void addFirst(Object o) {
        if (!visited.contains (o)){
            list.addFirst (o);
            visited.add (o);
        }
            
    }
    public void addLast (Object o) {
        if (!visited.contains (o)){
            list.addLast (o);
            visited.add (o);
        }
    }
    public Object removeFirst () {
        Object o = list.removeFirst ();
        return o;
    }

    public Object removeLast () {
        Object o = list.removeLast ();
        return o;
    }
    public void clear () {
        list.clear();
        visited.clear();
    }


    public Iterator iterator () {
        return list.iterator();
    }
    public int size () {
        return list.size();
    }

};
