/*
 * @(#)$Id: GHello.java,v 1.1.1.1 2002/11/06 22:10:27 kris Exp $
 *
 * Copyright (c)1999 Regents of the University of California
 *
 */

package mokan.test;

import java.util.*;
import mokan.KanSystem;
import mokan.app.Application;
import mokan.obj.*;
import mokan.thread.*;
import mokan.transact.*;

/**
 * Say hello from a distance
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:27 $
 * @author	Sandeep Bhatia
 * @author	Sean Brydon
 * @author	Jerry James
 */
public class GHello implements GlobalObj, Cloneable {
    public ObjectID objID;

    public GuardCondition gc = new GuardCondition("notEmpty", null);

    public GHello() {
	objID = null;
    }

    public GHello(ObjectID oid) {
	objID = oid;
    }

    public void sayHello() {
	System.out.println("==============================");
	System.out.println("==============================");
	System.out.println("Hello World!");
	System.out.println("==============================");
	System.out.println("==============================");
    }

    public static void main(Application app, String argv[]) {
	try {
	    System.err.println("Creating object 1");
	    ObjectID oid1 = KanSystem.newKanObject(GHello.class, null);
	    System.err.println("Creating object 2");
	    ObjectID oid2 = KanSystem.newKanObject(GHello.class, null);
	    System.err.println("Creating object 3");
	    ObjectID oid3 = KanSystem.newKanObject(GHello.class, null);
	    System.err.println("Creating object 4");
	    ObjectID oid4 = KanSystem.newKanObject(GHello.class, null);

	    System.err.println("Invoking sayHello on object 1");
	    Future f1 = KanSystem.invokeMethod(oid1, "sayHello", null, true);
	    System.err.println("Invoking sayHello on object 2");
	    Future f2 = KanSystem.invokeMethod(oid2, "sayHello", null, true);
	    System.err.println("Invoking sayHello on object 3");
	    Future f3 = KanSystem.invokeMethod(oid3, "sayHello", null, true);
	    System.err.println("Invoking sayHello on object 4");
	    Future f4 = KanSystem.invokeMethod(oid4, "sayHello", null, true);

	    System.err.println("Waiting for " + f1);
	    f1.join();
	    System.err.println("Waiting for " + f2);
	    f2.join();
	    System.err.println("Waiting for " + f3);
	    f3.join();
	    System.err.println("Waiting for " + f4);
	    f4.join();

	    System.out.println("********* Exiting GHello! **************");

	} catch(TransactionException tae) {
	    tae.printStackTrace();
	} catch(NoSuchKanObjectException nskoe) {
	    nskoe.printStackTrace();
	} catch(NoSuchMethodException nsme) {
	    nsme.printStackTrace();
	}
    }

    public GlobalObj kanClone() {
	try {
	    return (GlobalObj)clone();
	} catch (CloneNotSupportedException cloneEx) {
	    return null;
	}
    }

    public void kanSetObject(GlobalObj obj) {
	// Do nothing; this object has no state to set
    }
}
