package mokan.test.WebCache;

import java.io.*;
import java.net.*;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.StringTokenizer;
import mokan.KanSystem;
import mokan.obj.ObjectID;
import mokan.obj.NoSuchKanObjectException;
import mokan.thread.Future;
import mokan.transact.TransactionException;

public class ServiceThread
implements Runnable
{
    Socket userSocket;
    Hashtable proxyCache;
    LinkedList LRUList;
    Proxy myProxy;
    
    Thread t;
    
    ServiceThread(Socket newRequest, Proxy myProxy)
    {
	userSocket = newRequest;
	this.myProxy = myProxy;
	proxyCache = myProxy.getWebCache();
	LRUList = myProxy.getLastUsed();
	t = new Thread(this);
	t.start();
    }
    
    public void run()
    {
	try {
	    // first read the input and find out the file request
	    BufferedReader br = new BufferedReader
		(new InputStreamReader(userSocket.getInputStream()));
	    PrintStream prn = new PrintStream(userSocket.getOutputStream());
	    String userRequest = br.readLine();
	    String requestURL = parseRequest(userRequest);

	    // first check the local cache
	    CacheID requestCacheID;
	    if ((requestCacheID = (CacheID)proxyCache.get(userRequest)) 
		== null) {
		// implies dude ain't here. Should search the other guys
		// or ask the webserver
		myProxy.searchOtherProxies(userRequest);
		// for now the assumption is that user always makes a valid
		// request, hence above always returns true
		requestCacheID = (CacheID)proxyCache.get(userRequest);

		// Think the above statement should be eliminated. 
		// 'searchOtherProxies' can itself return the
		// cacheID of the file desired.
	    }
	    // KanSystem.guardBegin();
	    ObjectID requestObjId = requestCacheID.getObjID();
	    Future fGetData = KanSystem.invokeMethod(requestObjId,
						     "getData",
						     null, false);
	    byte[] data = (byte[])fGetData.joinObject();
	    // change the state of the LinkedList
	

	    // KanSystem.guardEnd();
	    prn.write(data, 0, data.length);
	    userSocket.close();
	}
	catch (IOException ioe) {
	    ioe.printStackTrace();
	}
	catch (TransactionException te) {
	    te.printStackTrace();
	}
	catch (NoSuchKanObjectException nskoe) {
	    nskoe.printStackTrace();
	}
	catch (NoSuchMethodException nsme) {
	    nsme.printStackTrace();
	}
    }

    public String parseRequest(String userRequest)
    {
	StringTokenizer getRequest = new StringTokenizer(userRequest);
	String reqType  = getRequest.nextToken(); // 'GET'
	String fileName = getRequest.nextToken(); // the filename
	String httpVer  = getRequest.nextToken(); // the HTTP Version
	return (fileName);
    }
}
