/*
 * @(#)$Id: NestedTransactionID.java,v 1.1.1.1 2002/11/06 22:10:27 kris Exp $
 *
 * Copyright (c)1999 Regents of the University of California
 */

package mokan.test.rmiTest;

import java.io.Serializable;

/**
 * A dummy class for estimating the relative network performances of Java RMI
 * and Kan
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:27 $
 * @author	Jerry James
 */
public class NestedTransactionID extends TransactionID implements Serializable
{
    public NestedTransactionID parent;
    public NestedTransactionID topLevel;
    int level;

    public NestedTransactionID(LogicalNode node, NestedTransactionID parent) {
	super(node);
	if (parent != null) {
	    this.parent = parent;
	    topLevel = parent.topLevel;
	    level = parent.level + 1;
	} else {
	    parent = null;
	    topLevel = this;
	    level = 1;
	}
    }
}
