/*
 * @(#)$Id: Tree.java,v 1.1.1.1 2002/11/06 22:10:28 kris Exp $
 *
 * Copyright (c)1999 Regents of the University of California
 *
 */

package mokan.test.rmiTest;

import java.io.Serializable;
import java.util.Random;

/**
 * A representation of a tree
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:28 $
 * @author	Sean Brydon
 * @author	Sandeep Bhatia
 * @author	Jerry James
 */
public final class Tree implements Serializable {

    /**
     * The <var>serialVersionUID</var> for this class.  If you change the
     * signature of this class (field names or types, method names, parameter
     * names or types, adding or removing fields or methods, etc.), you
     * <strong>must</strong> change this value.  The recommended way is to use
     * the <code>serialver</code> tool.
     */
    private static final long serialVersionUID = 2787793209645795147L;

    private int dummy1;
    private int dummy2;
    private int dummy3;
    private int dummy4;
    private Tree left;
    private Tree right;

    public Tree(Random rand) {
	this(rand, null, null);
    }

    public Tree(Random rand, Tree left, Tree right) {
	dummy1 = rand.nextInt();
	dummy2 = rand.nextInt();
	dummy3 = rand.nextInt();
	dummy4 = rand.nextInt();
	this.left = left;
	this.right = right;
    }

    public static Tree makeTree(Random rand) {
	return makeLevel(rand, 0);
    }

    private static Tree makeLevel(Random rand, int level) {
	if (level > 3)
	    return null;
	Tree left = makeLevel(rand, level + 1);
	Tree right = makeLevel(rand, level + 1);
	return new Tree(rand, left, right);
    }
}
