/*
  My first KAN application involving a Distributed Queue and a Set
  Fires a Queue, Set, Producer, Consumer and Debugger object on five nodes
 */

package mokan.test;

import java.util.*;
import mokan.*;
import mokan.obj.*;
import mokan.thread.*;
import mokan.app.Application;
import mokan.thread.trans.*;
 
public class GQSet implements GlobalObj, Cloneable {
    public ObjectID objID;

    public GuardCondition gc = new GuardCondition("notEmpty", null);

    public GQSet() {
	objID = null;
    }

    public GQSet(ObjectID oid) {
	objID = oid;
    }

// Insert a String into the Queue and Set simultaneously 
    public void insertQSet(String insStr) {
    }
    
// Delete a String from the Queue and Set simultaneously
    public String deleteQSet() {
    }

    public static void main(AppInfo app, String argv[]) {
	try {
// Create the global objects
	    System.err.println("Creating queue 1");
	    ObjectID oid1 = KanSystem.newKanObject(GQSet.class, null);
	   
// Invoke the appropriate methods
	    System.err.println("Invoking sayHello on object 1");
	    Future f1 = KanSystem.invokeMethod(oid1, "sayHello", null, true);

// Wait to return and then join
	    System.err.println("Waiting for " + f1);
	    f1.join();

	    System.out.println("********* Exiting GHello! **************");

	} catch(TransactionException tae) {
	    tae.printStackTrace();
	} catch(NoSuchKanObjectException nskoe) {
	    nskoe.printStackTrace();
	} catch(ThreadInvokeException tie) {
	    tie.printStackTrace();
	}
    }

    public GlobalObj kanClone() {
	try {
	    return (GlobalObj)clone();
	} catch (CloneNotSupportedException cloneEx) {
	    return null;
	}
    }

    public void kanSetObject(GlobalObj obj) {
	// Do nothing; this object has no state to set
    }
}
