/*
 * @(#)$Id: MakeSerializedData.java,v 1.1.1.1 2002/11/06 22:10:28 kris Exp $
 *
 * Copyright (c)1999 Regents of the University of California
 */

package mokan.test.speed;

import java.io.*;
import java.util.Date;
import java.util.Random;

/**
 * Make a file containing serialized data so we can read it back in for the
 * deserialization test.
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:28 $
 * @author	Jerry James
 */
public final class MakeSerializedData {

    public static void main(String[] argv)
	throws FileNotFoundException, IOException {

	int loops = Integer.parseInt(argv[0]);
	Random rand = new Random();

	FileOutputStream output = new FileOutputStream("serialInt");
	ObjectOutputStream out = new ObjectOutputStream(output);
	for (int i = 0; i < loops; i++) {
	    Integer myInt = new Integer(rand.nextInt());
	    out.writeObject(myInt);
	}
	out.flush();
	out.close();
	output.close();

	output = new FileOutputStream("serialDate");
	out = new ObjectOutputStream(output);
	for (int i = 0; i < loops; i++) {
	    Date d = new Date();
	    out.writeObject(d);
	}
	out.flush();
	out.close();
	output.close();

	output = new FileOutputStream("serialArray");
	out = new ObjectOutputStream(output);
	for (int i = 0; i < loops; i++) {
	    byte[] b = new byte[300];
	    out.writeObject(b);
	}
	out.flush();
	out.close();
	output.close();
    }
}
