/*
 * @(#)$Id: MethodCall.java,v 1.1.1.1 2002/11/06 22:10:28 kris Exp $
 *
 * Copyright (c)1999 Regents of the University of California
 */

package mokan.test.speed;

/**
 * A test of the speed of Java method calls.
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:28 $
 * @author	Jerry James
 */
public final class MethodCall {

    public static void main(String[] argv) {
	int loops = Integer.parseInt(argv[0]);
	MethodCall meth = new MethodCall();
	meth.doEmptyMethods(loops);
	meth.doMostlyEmptyMethods(loops);
	meth.doOneParam(loops);
    }

    private void doEmptyMethods(int loops) {
	long startTime = System.currentTimeMillis();
	for (int i = 0; i < loops; i++) {
	    emptyMethod1();
	    emptyMethod2();
	    emptyMethod3();
	    emptyMethod4();
	    emptyMethod5();
	}
	long endTime = System.currentTimeMillis();
	long totalTime = endTime - startTime;

	startTime = System.currentTimeMillis();
	for (int i = 0; i < loops; i++) {
	    // Do nothing; just time the loop
	}
	endTime = System.currentTimeMillis();
	long adjustedTime = totalTime - endTime + startTime;
	System.out.println("Adjusted time: " + adjustedTime);
	System.out.println("Milliseconds per method call: " +
			   (((double)adjustedTime / loops) / 5));
    }

    public void emptyMethod1() {
    }

    public void emptyMethod2() {
    }

    public void emptyMethod3() {
    }

    public void emptyMethod4() {
    }

    public void emptyMethod5() {
    }

    private void doMostlyEmptyMethods(int loops) {
	long startTime = System.currentTimeMillis();
	for (int i = 0; i < loops; i++) {
	    mostlyEmptyMethod1();
	    mostlyEmptyMethod2();
	    mostlyEmptyMethod3();
	    mostlyEmptyMethod4();
	    mostlyEmptyMethod5();
	}
	long endTime = System.currentTimeMillis();
	long totalTime = endTime - startTime;

	startTime = System.currentTimeMillis();
	for (int i = 0; i < loops; i++) {
	    // Do nothing; just time the loop
	}
	endTime = System.currentTimeMillis();
	long adjustedTime = totalTime - endTime + startTime;
	System.out.println("Adjusted time: " + adjustedTime);
	System.out.println("Milliseconds per method call: " +
			   (((double)adjustedTime / loops) / 5));
    }

    public int mostlyEmptyMethod1() {
	return 1;
    }

    public int mostlyEmptyMethod2() {
	return 2;
    }

    public int mostlyEmptyMethod3() {
	return 3;
    }

    public int mostlyEmptyMethod4() {
	return 4;
    }

    public int mostlyEmptyMethod5() {
	return 5;
    }

    private void doOneParam(int loops) {
	long startTime = System.currentTimeMillis();
	for (int i = 0; i < loops; i++) {
	    oneParamMethod1(1);
	    oneParamMethod2(2);
	    oneParamMethod3(3);
	    oneParamMethod4(4);
	    oneParamMethod5(5);
	}
	long endTime = System.currentTimeMillis();
	long totalTime = endTime - startTime;

	startTime = System.currentTimeMillis();
	for (int i = 0; i < loops; i++) {
	    // Do nothing; just time the loop
	}
	endTime = System.currentTimeMillis();
	long adjustedTime = totalTime - endTime + startTime;
	System.out.println("Adjusted time: " + adjustedTime);
	System.out.println("Milliseconds per method call: " +
			   (((double)adjustedTime / loops) / 5));
    }

    public int oneParamMethod1(int x) {
	return 1;
    }

    public int oneParamMethod2(int x) {
	return 2;
    }

    public int oneParamMethod3(int x) {
	return 3;
    }

    public int oneParamMethod4(int x) {
	return 4;
    }

    public int oneParamMethod5(int x) {
	return 5;
    }
}
