/*
 * @(#)$Id: TimeTest.java,v 1.1.1.1 2002/11/06 22:10:28 kris Exp $
 *
 * Copyright (c)1999 Regents of the University of California
 */

package mokan.test.speed;

import mokan.util.Timer;

/**
 * This is a test of the millisecond and nanosecond clocks.
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:28 $
 * @author	Jerry James
 */
public final class TimeTest {

    public static void main(String[] argv) {
	int loops = Integer.parseInt(argv[0]);

	// MILLISECOND CLOCK TEST:

	/*
	long startTime = System.currentTimeMillis();
	for (int i = 0; i < loops; i++) {
	    long junkTime = System.currentTimeMillis();
	}
	long totalTime = System.currentTimeMillis() - startTime;

	System.out.println("Total time (milliseconds): " + totalTime);
	System.out.println("Milliseconds per time lookup: " +
			   ((double)totalTime / loops));
	*/

	// NANOSECOND CLOCK TEST:
	// Do all the linking here, since that's pretty slow
	long dummyTime = Timer.currentTimeNanos();

	long startTime = Timer.currentTimeNanos();
	for (int i = 0; i < loops; i++) {
	    long junkTime = Timer.currentTimeNanos();
	}
	long totalTime = Timer.currentTimeNanos() - startTime;

	System.out.println("Dummy time, to fool the optimizer: " + dummyTime);
	System.out.println("Total time (nanoseconds): " + totalTime);
	System.out.println("Nanoseconds per time lookup: " +
			   ((double)totalTime / loops));
    }
}
