/**
 * IsolationRequest
 * Copyright kkvilekval@acm.org.   See COPYRIGHT for details.
 */
package mokan.transact;


import java.io.Externalizable;
import mokan.comm.LogicalNode;
import mokan.obj.GuardCondition;
import mokan.obj.ObjectID;
import mokan.obj.GlobalObj;
import mokan.thread.AsynchCall;

/**
 * A request for a lock on a <code>KanObject</code>, for reading, writing, or
 * copying the object, only when some predicate (guard) is satisfied.
 *  
 *  @version $Revision$, $Date$
 *  @author Kristian Kvilekval (kkvilekval@acm.org)
 */
public interface IsolationRequest {//implements Comparable, Externalizable {
    /* Private/Public Variables */

    public  TransactionID getTransactionID();
    public  LogicalNode   getRequestingNode();
    public  boolean       guardSatisfied(GlobalObj obj);
    public  ObjectID      getObjectID();
    public  void          setTimestamp(long version);
    public  boolean isReadOnly();
}
