/**
 * OptimisticVersionException
 * Copyright kkvilekval@acm.org.   See COPYRIGHT for details.
 */
package mokan.transact;

/**
 *  The <code>OptimisticVersionException</code> signals that an optimistic
 *  lock has failed to commit due to a version mismatch.
 *  @version $Revision$, $Date$
 *  @author Kristian Kvilekval (kkvilekval@acm.org)
 */
public class OptimisticVersionException extends TransactionAbortException {
    /* Private/Public Variables */
    long request_version;
    long object_version;

    
    public OptimisticVersionException (long req, long obj){
         request_version = req;
         object_version = obj;
    }

    public String toString () {
        return "OptimistVersionException("+object_version+","+request_version+")";
    }
}
