/*
 * @(#)$Id
 *
 *
 */

package mokan.ui;

import java.util.Vector;

/**
 * This is a container class to record the status of the KVM; i.e., which
 * machines it is running on, etc.
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:29 $
 * @author	Sean Brydon
 * @author	Sandeep Bhatia
 */
final class KanStatus {
    private final int IdNo;
    private final Vector listOfMachines = new Vector();
    int lastMachMarker = 0;
    
    KanStatus(final int thisKVM) {
	IdNo = thisKVM ;
    }

    void addMachine(final String newMachine) {
	listOfMachines.addElement(newMachine);
    }

    String[] getMachines() {
	final String machineNames[] = new String[listOfMachines.size()];
	for (int i = 0; i < listOfMachines.size(); i++) {
	    machineNames[i] = (String)listOfMachines.elementAt(i);
	}
	return machineNames;
    }

    int totalMachines() {
	return listOfMachines.size();
    }
}
