/*
 * @(#)$Id: Timer.java,v 1.1.1.1 2002/11/06 22:10:29 kris Exp $
 *
 */

package mokan.util;

/**
 * This is a convenience class for accessing timers with higher resolution
 * than 1 millisecond.  It uses native code to access such timers on platforms 
 * where they are available.
 *
 * @version	$Revision: 1.1.1.1 $, $Date: 2002/11/06 22:10:29 $
 * @author	Jerry James
 */
public final class Timer {

    static {
	final String arch    = System.getProperty("os.arch");
	final String os      = System.getProperty("os.name");
	final String version = System.getProperty("os.version");
	final String desc    = arch + '-' + os + version;
	try {
	    System.loadLibrary(desc);
	} catch (UnsatisfiedLinkError noLibError) {
	    System.err.println("Timer.currentTimeNanos not supported on " +
			       desc);
	}
    }

    public static native long currentTimeNanos();
}
